diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/txop.h ns-3.36/src/wifi/model/txop.h
--- ns-3.35/src/wifi/model/txop.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/txop.h	2022-04-30 18:23:58.214735300 -0700
@@ -34,7 +34,7 @@
 class WifiMacQueueItem;
 class UniformRandomVariable;
 class CtrlBAckResponseHeader;
-class RegularWifiMac;
+class WifiMac;
 enum WifiMacDropReason : uint8_t;  // opaque enum declaration
 
 /**
@@ -114,7 +114,7 @@
    *
    * \param mac associated wifi MAC
    */
-  virtual void SetWifiMac (const Ptr<RegularWifiMac> mac);
+  virtual void SetWifiMac (const Ptr<WifiMac> mac);
   /**
    * Set MacTxMiddle this Txop is associated to.
    *
@@ -198,10 +198,6 @@
   void UpdateFailedCw (void);
 
   /**
-   * When a channel switching occurs, enqueued packets are removed.
-   */
-  virtual void NotifyChannelSwitching (void);
-  /**
    * When sleep operation occurs, if there is a pending packet transmission,
    * it will be reinserted to the front of the queue.
    */
@@ -326,7 +322,7 @@
   DroppedMpdu m_droppedMpduCallback;                //!< the dropped MPDU callback
   Ptr<WifiMacQueue> m_queue;                        //!< the wifi MAC queue
   Ptr<MacTxMiddle> m_txMiddle;                      //!< the MacTxMiddle
-  Ptr<RegularWifiMac> m_mac;                        //!< the wifi MAC
+  Ptr<WifiMac> m_mac;                               //!< the wifi MAC
   Ptr<UniformRandomVariable> m_rng;                 //!< the random stream
 
   uint32_t m_cwMin;              //!< the minimum contention window
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/vht/vht-frame-exchange-manager.cc ns-3.36/src/wifi/model/vht/vht-frame-exchange-manager.cc
--- ns-3.35/src/wifi/model/vht/vht-frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/vht/vht-frame-exchange-manager.cc	2022-04-30 18:23:58.214735300 -0700
@@ -58,4 +58,12 @@
   return Create<WifiPsdu> (mpdu, txVector.GetModulationClass () >= WIFI_MOD_CLASS_VHT);
 }
 
+uint32_t
+VhtFrameExchangeManager::GetPsduSize (Ptr<const WifiMacQueueItem> mpdu, const WifiTxVector& txVector) const
+{
+  return (txVector.GetModulationClass () >= WIFI_MOD_CLASS_VHT
+          ? MpduAggregator::GetSizeIfAggregated (mpdu->GetSize (), 0)
+          : HtFrameExchangeManager::GetPsduSize (mpdu, txVector));
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/vht/vht-frame-exchange-manager.h ns-3.36/src/wifi/model/vht/vht-frame-exchange-manager.h
--- ns-3.35/src/wifi/model/vht/vht-frame-exchange-manager.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/vht/vht-frame-exchange-manager.h	2022-04-30 18:23:58.214735300 -0700
@@ -44,6 +44,7 @@
 
 protected:
   Ptr<WifiPsdu> GetWifiPsdu (Ptr<WifiMacQueueItem> mpdu, const WifiTxVector& txVector) const override;
+  uint32_t GetPsduSize (Ptr<const WifiMacQueueItem> mpdu, const WifiTxVector& txVector) const override;
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/vht/vht-phy.cc ns-3.36/src/wifi/model/vht/vht-phy.cc
--- ns-3.35/src/wifi/model/vht/vht-phy.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/vht/vht-phy.cc	2022-04-30 18:23:58.214735300 -0700
@@ -377,14 +377,13 @@
   return WifiModeFactory::CreateWifiMcs ("VhtMcs" + std::to_string (index),
                                          index,
                                          WIFI_MOD_CLASS_VHT,
+                                         false,
                                          MakeBoundCallback (&GetCodeRate, index),
                                          MakeBoundCallback (&GetConstellationSize, index),
-                                         MakeBoundCallback (&GetPhyRate, index),
                                          MakeCallback (&GetPhyRateFromTxVector),
-                                         MakeBoundCallback (&GetDataRate, index),
                                          MakeCallback (&GetDataRateFromTxVector),
                                          MakeBoundCallback (&GetNonHtReferenceRate, index),
-                                         MakeBoundCallback (&IsModeAllowed, index));
+                                         MakeCallback (&IsAllowed));
 }
 
 WifiCodeRate
@@ -445,7 +444,7 @@
 {
   NS_ASSERT (guardInterval == 800 || guardInterval == 400);
   NS_ASSERT (nss <= 8);
-  NS_ASSERT_MSG (IsModeAllowed (mcsValue, channelWidth, nss), "VHT MCS " << +mcsValue << " forbidden at " << channelWidth << " MHz when NSS is " << +nss);
+  NS_ASSERT_MSG (IsCombinationAllowed (mcsValue, channelWidth, nss), "VHT MCS " << +mcsValue << " forbidden at " << channelWidth << " MHz when NSS is " << +nss);
   return HtPhy::CalculateDataRate (3.2, guardInterval,
                                    GetUsableSubcarriers (channelWidth),
                                    static_cast<uint16_t> (log2 (GetConstellationSize (mcsValue))),
@@ -497,7 +496,15 @@
 }
 
 bool
-VhtPhy::IsModeAllowed (uint8_t mcsValue, uint16_t channelWidth, uint8_t nss)
+VhtPhy::IsAllowed (const WifiTxVector& txVector)
+{
+  return IsCombinationAllowed (txVector.GetMode ().GetMcsValue (),
+                               txVector.GetChannelWidth (),
+                               txVector.GetNss ());
+}
+
+bool
+VhtPhy::IsCombinationAllowed (uint8_t mcsValue, uint16_t channelWidth, uint8_t nss)
 {
   if (mcsValue == 9 && channelWidth == 20 && nss != 3)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/vht/vht-phy.h ns-3.36/src/wifi/model/vht/vht-phy.h
--- ns-3.35/src/wifi/model/vht/vht-phy.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/vht/vht-phy.h	2022-04-30 18:23:58.214735300 -0700
@@ -253,7 +253,15 @@
    * \param nss the considered number of streams
    * \returns true if this <MCS, channel width, NSS> combination is allowed, false otherwise.
    */
-  static bool IsModeAllowed (uint8_t mcsValue, uint16_t channelWidth, uint8_t nss);
+  static bool IsCombinationAllowed (uint8_t mcsValue, uint16_t channelWidth, uint8_t nss);
+  /**
+   * Check whether the combination in TXVECTOR is allowed.
+   * This function is used as a callback for WifiMode operation.
+   *
+   * \param txVector the TXVECTOR
+   * \returns true if this combination is allowed, false otherwise.
+   */
+  static bool IsAllowed (const WifiTxVector& txVector);
 
 protected:
   WifiMode GetHtSigMode (void) const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/vht/vht-ppdu.cc ns-3.36/src/wifi/model/vht/vht-ppdu.cc
--- ns-3.35/src/wifi/model/vht/vht-ppdu.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/vht/vht-ppdu.cc	2022-04-30 18:23:58.214735300 -0700
@@ -219,7 +219,7 @@
 bool
 VhtPpdu::VhtSigHeader::GetShortGuardInterval (void) const
 {
-  return m_sgi ? true : false;
+  return m_sgi;
 }
 
 void
@@ -231,7 +231,7 @@
 bool
 VhtPpdu::VhtSigHeader::GetShortGuardIntervalDisambiguation (void) const
 {
-  return m_sgi_disambiguation ? true : false;
+  return m_sgi_disambiguation;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-ack-manager.cc ns-3.36/src/wifi/model/wifi-ack-manager.cc
--- ns-3.35/src/wifi/model/wifi-ack-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-ack-manager.cc	2022-04-30 18:23:58.214735300 -0700
@@ -21,7 +21,7 @@
 #include "ns3/log.h"
 #include "wifi-ack-manager.h"
 #include "wifi-psdu.h"
-#include "regular-wifi-mac.h"
+#include "wifi-mac.h"
 
 
 namespace ns3 {
@@ -54,7 +54,7 @@
 }
 
 void
-WifiAckManager::SetWifiMac (Ptr<RegularWifiMac> mac)
+WifiAckManager::SetWifiMac (Ptr<WifiMac> mac)
 {
   NS_LOG_FUNCTION (this << mac);
   m_mac = mac;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-ack-manager.h ns-3.36/src/wifi/model/wifi-ack-manager.h
--- ns-3.35/src/wifi/model/wifi-ack-manager.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-ack-manager.h	2022-04-30 18:23:58.214735300 -0700
@@ -31,7 +31,7 @@
 class WifiTxParameters;
 class WifiMacQueueItem;
 class WifiPsdu;
-class RegularWifiMac;
+class WifiMac;
 
 /**
  * \ingroup wifi
@@ -54,7 +54,7 @@
    *
    * \param mac a pointer to the MAC
    */
-  void SetWifiMac (Ptr<RegularWifiMac> mac);
+  void SetWifiMac (Ptr<WifiMac> mac);
 
   /**
    * Set the QoS Ack policy for the given MPDU, which must be a QoS data frame.
@@ -101,7 +101,7 @@
 protected:
   void DoDispose (void) override;
 
-  Ptr<RegularWifiMac> m_mac;     //!< MAC which is using this Acknowledgment Manager
+  Ptr<WifiMac> m_mac; //!< MAC which is using this Acknowledgment Manager
 };
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-acknowledgment.cc ns-3.36/src/wifi/model/wifi-acknowledgment.cc
--- ns-3.35/src/wifi/model/wifi-acknowledgment.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-acknowledgment.cc	2022-04-30 18:23:58.214735300 -0700
@@ -334,7 +334,8 @@
  */
 
 WifiUlMuMultiStaBa::WifiUlMuMultiStaBa ()
-  : WifiAcknowledgment (UL_MU_MULTI_STA_BA)
+  : WifiAcknowledgment (UL_MU_MULTI_STA_BA),
+    baType (BlockAckType::MULTI_STA)
 {
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-default-ack-manager.cc ns-3.36/src/wifi/model/wifi-default-ack-manager.cc
--- ns-3.35/src/wifi/model/wifi-default-ack-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-default-ack-manager.cc	2022-04-30 18:23:58.214735300 -0700
@@ -654,7 +654,6 @@
     {
       // the only supported ack method for now is through a multi-STA BlockAck frame
       WifiUlMuMultiStaBa* acknowledgment = new WifiUlMuMultiStaBa;
-      acknowledgment->baType.m_variant = BlockAckType::MULTI_STA;
 
       for (const auto& userInfo : trigger)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-default-protection-manager.cc ns-3.36/src/wifi/model/wifi-default-protection-manager.cc
--- ns-3.35/src/wifi/model/wifi-default-protection-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-default-protection-manager.cc	2022-04-30 18:23:58.214735300 -0700
@@ -22,7 +22,7 @@
 #include "wifi-default-protection-manager.h"
 #include "wifi-tx-parameters.h"
 #include "wifi-mac-queue-item.h"
-#include "regular-wifi-mac.h"
+#include "wifi-mac.h"
 
 
 namespace ns3 {
@@ -58,6 +58,30 @@
 {
   NS_LOG_FUNCTION (this << *mpdu << &txParams);
 
+  // TB PPDUs need no protection (the soliciting Trigger Frame can be protected
+  // by an MU-RTS). Until MU-RTS is implemented, we disable protection also for:
+  // - Trigger Frames
+  // - DL MU PPDUs containing more than one PSDU
+  if (txParams.m_txVector.IsUlMu ()
+      || mpdu->GetHeader ().IsTrigger ()
+      || (txParams.m_txVector.IsDlMu () && txParams.GetPsduInfoMap ().size () > 1))
+    {
+      if (txParams.m_protection)
+        {
+          NS_ASSERT (txParams.m_protection->method == WifiProtection::NONE);
+          return nullptr;
+        }
+      return std::unique_ptr<WifiProtection> (new WifiNoProtection);
+    }
+
+  // If we are adding a second PSDU to a DL MU PPDU, switch to no protection
+  // (until MU-RTS is implemented)
+  if (txParams.m_txVector.IsDlMu () && txParams.GetPsduInfoMap ().size () == 1
+      && txParams.GetPsduInfo (mpdu->GetHeader ().GetAddr1 ()) == nullptr)
+    {
+      return std::unique_ptr<WifiProtection> (new WifiNoProtection);
+    }
+
   // if the current protection method (if any) is already RTS/CTS or CTS-to-Self,
   // it will not change by adding an MPDU
   if (txParams.m_protection
@@ -100,6 +124,12 @@
 
   NS_ASSERT (txParams.m_protection->method == WifiProtection::NONE);
 
+  // No protection for TB PPDUs
+  if (txParams.m_txVector.IsUlMu ())
+    {
+      return nullptr;
+    }
+
   std::unique_ptr<WifiProtection> protection;
   protection = GetPsduProtection (msdu->GetHeader (), txParams.GetSizeIfAggregateMsdu (msdu).second,
                                   txParams.m_txVector);
